User account creation filtered due to spam.

Bug 16959 - [3.4 Regression] Segmentation fault in ios_base::sync_with_stdio
Summary: [3.4 Regression] Segmentation fault in ios_base::sync_with_stdio
Status: RESOLVED FIXED
Alias: None
Product: gcc
Classification: Unclassified
Component: libstdc++ (show other bugs)
Version: 3.4.1
: P2 normal
Target Milestone: 3.4.2
Assignee: Paolo Carlini
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2004-08-10 09:31 UTC by Pétur Runólfsson
Modified: 2004-08-12 09:12 UTC (History)
1 user (show)

See Also:
Host: i686-pc-linux-gnu
Target: i686-pc-linux-gnu
Build: i686-pc-linux-gnu
Known to work:
Known to fail:
Last reconfirmed: 2004-08-10 20:55:19


Attachments
Test case (87 bytes, text/plain)
2004-08-10 09:34 UTC, Pétur Runólfsson
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Pétur Runólfsson 2004-08-10 09:31:14 UTC
In src/ios_init.cc:

  bool 
  ios_base::sync_with_stdio(bool __sync)
  { 
    // _GLIBCXX_RESOLVE_LIB_DEFECTS
    // 49.  Underspecification of ios_base::sync_with_stdio
    bool __ret = ios_base::Init::_S_synced_with_stdio;

    // Turn off sync with C FILE* for cin, cout, cerr, clog iff
    // currently synchronized.
    if (!__sync && __ret)
      {
        ios_base::Init::_S_synced_with_stdio = __sync;

        // Explicitly call dtors to free any memory that is
        // dynamically allocated by filebuf ctor or member functions,
        // but don't deallocate all memory by calling operator delete.
        buf_cout_sync.~stdio_sync_filebuf<char>();
        buf_cin_sync.~stdio_sync_filebuf<char>();
        buf_cerr_sync.~stdio_sync_filebuf<char>();

This is fine, except that there is no guarantee that buf_cout_sync and friends
have been constructed before this gets run. If the objects haven't been
constructed, the program segfaults.

A simple fix would be to construct an ios_base::Init object at the beginning
of the block.
Comment 1 Pétur Runólfsson 2004-08-10 09:34:17 UTC
Created attachment 6910 [details]
Test case

This works fine with 3.2.3 and 3.3.4, but segfaults with 3.4.1 and 3.5.
Comment 2 Paolo Carlini 2004-08-10 20:55:19 UTC
Thanks, Pétur.
Comment 3 CVS Commits 2004-08-11 09:31:25 UTC
Subject: Bug 16959

CVSROOT:	/cvs/gcc
Module name:	gcc
Changes by:	paolo@gcc.gnu.org	2004-08-11 09:31:13

Modified files:
	libstdc++-v3   : ChangeLog 
	libstdc++-v3/src: ios_init.cc 
Added files:
	libstdc++-v3/testsuite/27_io/ios_base/sync_with_stdio: 16959.cc 

Log message:
	2004-08-11  Paolo Carlini  <pcarlini@suse.de>
	Petur Runolfsson  <peturr02@ru.is>
	
	PR libstdc++/16959
	* src/ios_init.cc (ios_base::sync_with_stdio): Make sure the
	standard streams are constructed.
	* testsuite/27_io/ios_base/sync_with_stdio/16959.cc: New.

Patches:
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/libstdc++-v3/ChangeLog.diff?cvsroot=gcc&r1=1.2603&r2=1.2604
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/libstdc++-v3/src/ios_init.cc.diff?cvsroot=gcc&r1=1.6&r2=1.7
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/libstdc++-v3/testsuite/27_io/ios_base/sync_with_stdio/16959.cc.diff?cvsroot=gcc&r1=NONE&r2=1.1

Comment 4 CVS Commits 2004-08-12 09:11:14 UTC
Subject: Bug 16959

CVSROOT:	/cvs/gcc
Module name:	gcc
Branch: 	gcc-3_4-branch
Changes by:	paolo@gcc.gnu.org	2004-08-12 09:11:08

Modified files:
	libstdc++-v3   : ChangeLog 
	libstdc++-v3/src: ios_init.cc 
Added files:
	libstdc++-v3/testsuite/27_io/ios_base/sync_with_stdio: 16959.cc 

Log message:
	2004-08-12  Paolo Carlini  <pcarlini@suse.de>
	Petur Runolfsson  <peturr02@ru.is>
	
	PR libstdc++/16959
	* src/ios_init.cc (ios_base::sync_with_stdio): Make sure the
	standard streams are constructed.
	* testsuite/27_io/ios_base/sync_with_stdio/16959.cc: New.

Patches:
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/libstdc++-v3/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.2224.2.151&r2=1.2224.2.152
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/libstdc++-v3/src/ios_init.cc.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.4.4.1&r2=1.4.4.2
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/libstdc++-v3/testsuite/27_io/ios_base/sync_with_stdio/16959.cc.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=NONE&r2=1.1.2.1

Comment 5 Paolo Carlini 2004-08-12 09:12:11 UTC
Fixed for mainline and 3.4.2.